#include "AView.h"
BString AppPath(void)
{
	BPath path;
	app_info info; // Roster.h
	be_app->GetAppInfo(&info); 
	BEntry entry(&info.ref); 
	entry.GetPath(&path); 
	path.GetParent(&path);
	BString s(path.Path());
	return s;
}
TView::TView(BRect AFrame): BView(AFrame,NULL,B_FOLLOW_ALL_SIDES,B_NAVIGABLE | B_WILL_DRAW)
{
    fs_flag  = FALSE;
    ds_flag  = FALSE;
    pal_flag = FALSE;

	BRect ARectAButton(24.000000,148.000000,127.000000,171.000000);
	FAButton=new BButton(ARectAButton,"AButton","Load ROM",new BMessage(LOAD_ROM),B_FOLLOW_LEFT | B_FOLLOW_TOP,B_NAVIGABLE | B_WILL_DRAW);
	FAButton->MakeDefault(FALSE);
	AddChild(FAButton);
	BRect ARectACheckBoxPAL(24.000000,117.000000,156.000000,133.000000);
	FACheckBoxPAL=new BCheckBox(ARectACheckBoxPAL,"ACheckBoxPAL","PAL mode",new BMessage(CHECK_PAL),B_FOLLOW_LEFT | B_FOLLOW_TOP,B_NAVIGABLE | B_WILL_DRAW);
	AddChild(FACheckBoxPAL);
	BRect ARectACheckBox2x(23.000000,91.000000,154.000000,107.000000);
	FACheckBox2x=new BCheckBox(ARectACheckBox2x,"ACheckBox2x","Doubled window",new BMessage(CHECK_2X),B_FOLLOW_LEFT | B_FOLLOW_TOP,B_NAVIGABLE | B_WILL_DRAW);
	AddChild(FACheckBox2x);
	BRect ARectACheckBoxFS(23.000000,65.000000,154.000000,81.000000);
	FACheckBoxFS=new BCheckBox(ARectACheckBoxFS,"ACheckBoxFS","Full screen",new BMessage(CHECK_FS),B_FOLLOW_LEFT | B_FOLLOW_TOP,B_NAVIGABLE | B_WILL_DRAW);
	AddChild(FACheckBoxFS);
}
TView::~TView(void)
{
    delete fOpenPanel;
}
void TView::MessageReceived(BMessage *message)
{
	switch(message->what)
	{
	 case LOAD_ROM :
        fOpenPanel->Show();
		break;
	 case CHECK_FS :
        if(fs_flag == FALSE) fs_flag = TRUE;
        else fs_flag = FALSE; 
		break;
	 case CHECK_2X :
        if(ds_flag == FALSE) ds_flag = TRUE;
        else ds_flag = FALSE; 
		break;
	 case CHECK_PAL :
        if(pal_flag == FALSE) pal_flag = TRUE;
        else pal_flag = FALSE; 
		break;
     case B_REFS_RECEIVED :
        if (message->FindRef("refs", &ref) == B_NO_ERROR) StartDGen();
        break;
		default :
			BView::MessageReceived(message);
			break;
	}
}
void TView::AttachedToWindow(void)
{
	FACheckBoxPAL->SetTarget(this);
	FACheckBox2x->SetTarget(this);
	FACheckBoxFS->SetTarget(this);
	FAButton->SetTarget(this);
	BView::AttachedToWindow();
	fOpenPanel = new BFilePanel(B_OPEN_PANEL, new BMessenger(this), NULL, B_FILE_NODE, false);
}
void TView::StartDGen(void)
{
    command_line << AppPath();
    command_line << "/dgen ";      
    if(fs_flag == TRUE) command_line << "-f ";
    if(ds_flag == TRUE) command_line << "-X2 -Y2 ";
    if(pal_flag == TRUE) command_line << "-P ";
	BEntry entry(&ref,true);
	entry.GetPath(&fpath);
	command_line << fpath.Path();
	system(command_line.String());
    command_line.RemoveAll(command_line);
}